/*
 * AMX Mod constants
 *
 * (c) 2002-2010 - OLO/AMX Mod Team
 * This file is provided as is (no warranties).
 *
 */

#if defined _amxconst_included
  #endinput
#endif
#define _amxconst_included

// Uncomment if you are not using Steam (f.e.: CS 1.5 under Won)
//#define NO_STEAM

// Uncomment to use the colored admin activity
// Note: Do not uncomment this define if you are using
// another mod than Counter-Strike 1.6 or Condition Zero.
//#define COLORED_ACTIVITY

stock const AMX_VERSION[] = "2010.1"

/* PI & M_PI values (do not modify) */
#define PI   3.1415926535897932384626433832795
#define M_PI 3.1415926535897932384626433832795

/* Admin access flags */
#define ADMIN_ALL		        0
#define ADMIN_IMMUNITY       (1<<0)     /* Flag "a" */
#define ADMIN_RESERVATION    (1<<1)     /* Flag "b" */
#define ADMIN_KICK           (1<<2)     /* Flag "c" */
#define ADMIN_BAN            (1<<3)     /* Flag "d" */
#define ADMIN_SLAY           (1<<4)     /* Flag "e" */
#define ADMIN_MAP            (1<<5)     /* Flag "f" */
#define ADMIN_CVAR           (1<<6)     /* Flag "g" */
#define ADMIN_CFG            (1<<7)     /* Flag "h" */
#define ADMIN_CHAT           (1<<8)     /* Flag "i" */
#define ADMIN_VOTE           (1<<9)     /* Flag "j" */
#define ADMIN_PASSWORD      (1<<10)     /* Flag "k" */
#define ADMIN_RCON          (1<<11)     /* Flag "l" */
#define ADMIN_LEVEL_A       (1<<12)     /* Flag "m" */
#define ADMIN_LEVEL_B       (1<<13)     /* Flag "n" */
#define ADMIN_LEVEL_C       (1<<14)     /* Flag "o" */
#define ADMIN_LEVEL_D       (1<<15)     /* Flag "p" */
#define ADMIN_LEVEL_E       (1<<16)     /* Flag "q" */
#define ADMIN_LEVEL_F       (1<<17)     /* Flag "r" */
#define ADMIN_LEVEL_G       (1<<18)     /* Flag "s" */
#define ADMIN_LEVEL_H       (1<<19)     /* Flag "t" */
#define ADMIN_MENU          (1<<20)     /* Flag "u" */
#define ADMIN_PERMBAN       (1<<21)     /* Flag "v" */
#define ADMIN_UNBAN         (1<<22)     /* Flag "w" */
#define ADMIN_SUPREME       (1<<24)     /* Flag "y" */
#define ADMIN_USER          (1<<25)     /* Flag "z" */
#define ADMIN_ADMIN         25165823    /* All flags except "z" */

#define FLAG_KICK           (1<<0)      /* Flag "a" */
#define FLAG_TAG            (1<<1)      /* Flag "b" */
#define FLAG_AUTHID         (1<<2)      /* Flag "c" */
#define FLAG_IP             (1<<3)      /* Flag "d" */
#define FLAG_NOPASS         (1<<4)      /* Flag "e" */

#define PLUGIN_CONTINUE      0  /* Results returned by public functions */
#define PLUGIN_HANDLED       1  /* Stop other plugins */
#define PLUGIN_HANDLED_MAIN  2  /* To use in client_command(), continue all plugins but stop the command */

/* Menu keys: bits */
#define MENU_KEY_1     (1<<0)     /* Key/Case 1 */
#define MENU_KEY_2     (1<<1)     /* Key/Case 2 */
#define MENU_KEY_3     (1<<2)     /* Key/Case 3 */
#define MENU_KEY_4     (1<<3)     /* Key/Case 4 */
#define MENU_KEY_5     (1<<4)     /* Key/Case 5 */
#define MENU_KEY_6     (1<<5)     /* Key/Case 6 */
#define MENU_KEY_7     (1<<6)     /* Key/Case 7 */
#define MENU_KEY_8     (1<<7)     /* Key/Case 8 */
#define MENU_KEY_9     (1<<8)     /* Key/Case 9 */
#define MENU_KEY_0     (1<<9)     /* Key/Case 0 */
#define MENU_KEY_ALL    1023      /* All keys */

/* Menu keys: integers */
#define MENU_KEY_1_INT     0     /* Case 1 */
#define MENU_KEY_2_INT     1     /* Case 2 */
#define MENU_KEY_3_INT     2     /* Case 3 */
#define MENU_KEY_4_INT     3     /* Case 4 */
#define MENU_KEY_5_INT     4     /* Case 5 */
#define MENU_KEY_6_INT     5     /* Case 6 */
#define MENU_KEY_7_INT     6     /* Case 7 */
#define MENU_KEY_8_INT     7     /* Case 8 */
#define MENU_KEY_9_INT     8     /* Case 9 */
#define MENU_KEY_0_INT     9     /* Case 0 */

/* Flags for register_cvar() */
#define FCVAR_ARCHIVE             1  /* Set to cause it to be saved to vars.rc */
#define FCVAR_USERINFO            2  /* Changes the client's info string */
#define FCVAR_SERVER              4  /* Notifies players when changed */
#define FCVAR_EXTDLL              8  /* Defined by external DLL */
#define FCVAR_CLIENTDLL          16  /* Defined by the client dll */
#define FCVAR_PROTECTED          32  /* It's a server cvar, but we don't send the data since it's a password, etc.  Sends 1 if it's not bland/zero, 0 otherwise as value */
#define FCVAR_SPONLY             64  /* This cvar cannot be changed by clients connected to a multiplayer server. */
#define FCVAR_PRINTABLEONLY     128  /* This cvar's string cannot contain unprintable characters ( e.g., used for player name etc ). */
#define FCVAR_UNLOGGED          256  /* If this is a FCVAR_SERVER, don't log changes to the log file / console if we are creating a log */

/* Id of some items in Valve Mod */
#define HLI_HEALTHKIT     1  /* Healthkit */
#define HLI_ANTIDOTE      2  /* Antidote */
#define HLI_SECURITY      3  /* Security */
#define HLI_BATTERY       4  /* Battery */

/* Id of weapons in Valve Mod */
#define HLW_NONE          0  /* None */
#define HLW_CROWBAR       1  /* Crowbar */
#define HLW_GLOCK         2  /* Glock18 */
#define HLW_PYTHON        3  /* Colt Python */
#define HLW_MP5           4  /* H&K MP5 + Grenade Laucher */
#define HLW_CHAINGUN      5  /* ChainGun */
#define HLW_CROSSBOW      6  /* Crossbow */
#define HLW_SHOTGUN       7  /* ShotGun */
#define HLW_RPG           8  /* Rocket Laucher */
#define HLW_GAUSS         9  /* Gauss Gun */
#define HLW_EGON         10  /* Egon (aka Jetpack!) */
#define HLW_HORNETGUN    11  /* Hornet Gun */
#define HLW_HANDGRENADE  12  /* HE Grenade */
#define HLW_TRIPMINE     13  /* Tripmine */
#define HLW_SATCHEL      14  /* Satchel Grenade Backpack */
#define HLW_SNARK        15  /* Snark */
#define HLW_SUIT         31  /* Suit */
#define HLW_ALLWEAPONS  (~(1<<HLW_SUIT))

/* Id of weapons in CS (Counter-Strike/Condition Zero) */
#define CSW_P228          1  /* Sig P228 */
#define CSW_SCOUT         3  /* Steyr Scout */
#define CSW_HEGRENADE     4  /* HE Grenade */
#define CSW_XM1014        5  /* Benelli XM1014 */
#define CSW_C4            6  /* C4 */
#define CSW_MAC10         7  /* Ingram MAC-10 */
#define CSW_AUG           8  /* Steyr Aug */
#define CSW_SMOKEGRENADE  9  /* Smoke Grenade */
#define CSW_ELITE        10  /* Dual Beretta 96G Elite */
#define CSW_FIVESEVEN    11  /* FN Five-Seven */
#define CSW_UMP45        12  /* H&K UMP45 */
#define CSW_SG550        13  /* Sig SG-550 Sniper */
#define CSW_GALI         14  /* Galil */
#define CSW_GALIL        14  /* Galil */
#define CSW_FAMAS        15  /* Famas */
#define CSW_USP          16  /* H&K USP .45 Tactical */
#define CSW_GLOCK18      17  /* Glock18 Select Fire */
#define CSW_AWP          18  /* AI Arctic Warfare/Magnum */
#define CSW_MP5NAVY      19  /* H&K MP5-Navy */
#define CSW_M249         20  /* FN M249 Para */
#define CSW_M3           21  /* Benelli M3 Super90 */
#define CSW_M4A1         22  /* Colt M4A1 Carbine */
#define CSW_TMP          23  /* Steyr Tactical Machine Pistol */
#define CSW_G3SG1        24  /* H&K G3/SG-1 Sniper Rifle */
#define CSW_FLASHBANG    25  /* Flashbang */
#define CSW_DEAGLE       26  /* Desert Eagle .50AE */
#define CSW_SG552        27  /* Sig SG-552 Commando */
#define CSW_AK47         28  /* AK-47 */
#define CSW_KNIFE        29  /* Knife */
#define CSW_P90          30  /* FN P90 */
#define CSW_VEST         31  /* Kevlar Vest */
#define CSW_VESTHELM     32  /* Kevlar Vest & Helmet */

/* Parts of body for hits */
#define HIT_GENERIC   0  /* None */
#define HIT_HEAD      1
#define HIT_CHEST     2
#define HIT_STOMACH   3
#define HIT_LEFTARM   4
#define HIT_RIGHTARM  5
#define HIT_LEFTLEG   6
#define HIT_RIGHTLEG  7

/* Constants for emit_sound() */
/* Channels */
#define CHAN_AUTO                 0
#define CHAN_WEAPON               1
#define CHAN_VOICE                2
#define CHAN_ITEM                 3
#define CHAN_BODY                 4
#define CHAN_STREAM               5  /* Allocate stream channel from the static or dynamic area */
#define CHAN_STATIC               6  /* Allocate channel from the static area  */
#define CHAN_NETWORKVOICE_BASE    7  /* Voice data coming across the network */
#define CHAN_NETWORKVOICE_END   500  /* Network voice data reserves slots (CHAN_NETWORKVOICE_BASE through CHAN_NETWORKVOICE_END). */

/* Attenuation values */
#define ATTN_NONE    0.00
#define ATTN_NORM    0.80
#define ATTN_IDLE    2.00
#define ATTN_STATIC  1.25

/* Pitch values */
#define PITCH_NORM  100   /* Non-pitch shifted */
#define PITCH_LOW    95   /* Other values are possible - 0-255, where 255 is very high */
#define PITCH_HIGH  120

/* Volume values */
#define VOL_NORM  1.0
#define VOL_LOW   0.5

/* Flags for emit_sound() */
#define SND_SPAWNING      (1<<8)    // We're spawing, used in some cases for ambients
#define SND_STOP          (1<<5)    // Stop sound
#define SND_CHANGE_VOL    (1<<6)    // Change sound vol
#define SND_CHANGE_PITCH  (1<<7)    // Change sound pitch

/* Destination types for client_print() */
enum {
  print_notify = 1,
  print_console,
  print_chat,
  print_center,
};

/* Destination types for engclient_print() */
enum {
  engprint_console = 0,
  engprint_center,
  engprint_chat,
};

/* Render for set_user_rendering() */
enum {
  kRenderNormal = 0,   /* src */
  kRenderTransColor,   /* c*a+dest*(1-a) */
  kRenderTransTexture, /* src*a+dest*(1-a) */
  kRenderGlow,         /* src*a+dest -- No Z buffer checks */
  kRenderTransAlpha,   /* src*srca+dest*(1-srca) */
  kRenderTransAdd,     /* src*a+dest */
};

/* Fx for set_user_rendering() */
enum {
  kRenderFxNone = 0,
  kRenderFxPulseSlow,
  kRenderFxPulseFast,
  kRenderFxPulseSlowWide,
  kRenderFxPulseFastWide,
  kRenderFxFadeSlow,
  kRenderFxFadeFast,
  kRenderFxSolidSlow,
  kRenderFxSolidFast,
  kRenderFxStrobeSlow,
  kRenderFxStrobeFast,
  kRenderFxStrobeFaster,
  kRenderFxFlickerSlow,
  kRenderFxFlickerFast,
  kRenderFxNoDissipation,
  kRenderFxDistort,        /* Distort/scale/translate flicker */
  kRenderFxHologram,       /* kRenderFxDistort + distance fade */
  kRenderFxDeadPlayer,     /* kRenderAmt is the player index */
  kRenderFxExplode,        /* Scale up really big! */
  kRenderFxGlowShell,      /* Glowing Shell */
  kRenderFxClampMinScale,  /* Keep this sprite from getting very small (SPRITES only!) */
};

/* Force types for force_unmodified() */
enum {
  force_exactfile = 0,        /* File on client must exactly match server's file */
  force_model_samebounds,     /* For model files only, the geometry must fit in the same bbox */
  force_model_specifybounds,  /* For model files only, the geometry must fit in the specified bbox */
};
