/*
 * Core functions
 *
 * (c) Copyright 1998-2002 - ITB CompuPhase
 * This file is provided as is (no warranties).
 *
 */

#if defined _core_included
  #endinput
#endif
#define _core_included

/* Returns the free space on the heap. */
native heapspace();

/* Returns the index of a named public function. */
native funcidx(const name[]);

/* Retrieve an argument from an argument list. */
native getarg(arg, index = 0);

/* Set the value of an argument from an argument list. */
native setarg(arg, index = 0, value);

/* Returns the number of arguments passed to the current function. */
native numargs();

/* Returns the length of a zero terminated string. */
native strlen(const string[]);

/* Returns the lower case character code of c, or if not available, returns c. */
native tolower(c);

/* Returns the upper case character code of c, or if not available, returns c. */
native toupper(c);

/* Returns the value of c where all the bytes in the cell are swapped (low bye becomes high). */
native swapchars(c);

/* Returns a pseudo-random number in the range of 0 to max-1. */
native random(max);

/* Returns the lower value of val1 and val2. */
native min(value1, value2);

/* Returns the higher value of val1 and val2. */
native max(value1, value2);

/* Returns value if it is in the range min-max, min if value is lower than min, max if higher than max. */
native clamp(value, min = cellmin, max = cellmax);

/* Raises a value to a power. */
native power(value, exponent);

/* Approximates the integer square root of value. */
native sqroot(value);

/* Retrives the time. */
native time(&hour = 0, &minute = 0, &second = 0);

/* Retrieves the date. */
native date(&year = 0, &month = 0, &day = 0);

/* Unknown. Returns the integer difference in seconds? */
native tickcount(&granularity = 0);
