/*******************************************************************************

  cstrike.inc v1.0.6

  Authors: KRoT@L (v1.0.0 -> v1.0.4)
           AMX Mod Team (v1.0.5 -> v1.0.6)

  This file is the conversion of AMX Mod X's cstrike module.
  VexdUM has to be enabled to make these stocks work.
  Credits for the offsets and the initial code go to AMX Mod X Development Team.
  The authors of AMX Mod X are:
    David "BAILOPAN" Anderson, Pavol "PM OnoTo" Marko,
    Felix "SniperBeamer" Geyer, Jonny "Got His Gun" Bergstrom,
    Lukasz "SidLuke" Wlasinski, Christian "Basic-Master" Hammacher,
    Borja "faluco" Ferrer, Scott "Damaged Soul" Ehlert.

  Stocks:
    cs_get_user_money(id)
    cs_set_user_money(id, money, flash = 1)
    cs_get_user_deaths(id)
    cs_set_user_deaths(id, newdeaths)
    cs_get_weapon_id(weapon_id)
    cs_get_weapon_silen(weapon_id)
    cs_set_weapon_silen(weapon_id, silence = 1, draw_animation = 1)
    cs_get_weapon_burst(weapon_id)
    cs_set_weapon_burst(weapon_id, burstmode = 1)
    cs_get_user_armor(id, &CsArmorType:armortype)
    cs_set_user_armor(id, armorvalue, CsArmorType:armortype)
    cs_get_user_vip(id)
    cs_set_user_vip(id, vip = 1, model = 1, scoreboard = 1)
    CsTeams:cs_get_user_team(id, &{CsInternalModel,_}:model = CS_DONTCHANGE);
    cs_set_user_team(id, CsTeams:team, CsInternalModel:model = CS_DONTCHANGE)
    cs_get_user_buyzone(id)
    cs_get_user_plant(id)
    cs_set_user_plant(id, plant = 1, showbombicon = 1)
    cs_get_user_defuse(id)
    cs_set_user_defuse(id, defusekit = 1, r = 0, g = 160, b = 0, icon[] = "defuser", flash = 0)
    cs_get_user_bpammo(id, weapon)
    cs_set_user_bpammo(id, weapon, amount)
    cs_get_user_nvg(id)
    cs_set_user_nvg(id, nvgoggles = 1)
    cs_get_user_model(id, model[], len)
    cs_set_user_model(id, const model[])
    cs_reset_user_model(id)
    cs_get_hostage_id(hostage_id)
    cs_get_hostage_foll(hostage_id)
    cs_set_hostage_foll(hostage_id, followedid = 0)
    cs_get_weapon_ammo(weapon_id)
    cs_set_weapon_ammo(weapon_id, newammo)
    cs_get_user_hasprim(id)
    cs_get_user_tked(id)
    cs_set_user_tked(id, tk = 1, subtract = 1)
    cs_get_user_driving(id)
    cs_get_user_stationary(id)
    cs_get_user_shield(id)
    cs_user_spawn(id)
    cs_get_armoury_type(ent_id)
    cs_set_armoury_type(ent_id, type)
    cs_get_user_mapzones(id)
    cs_get_user_zoom(id)
    cs_get_user_submodel(id)
    cs_set_user_submodel(id, value)
    Float:cs_get_user_lastactivity(id)
    cs_set_user_lastactivity(id, Float:value)
    cs_get_user_hostagekills(id)
    cs_set_user_hostagekills(id, value)
    Float:cs_get_hostage_lastuse(hostage_id)
    cs_set_hostage_lastuse(hostage_id, Float:value)
    Float:cs_get_hostage_nextuse(hostage_id)
    cs_set_hostage_nextuse(hostage_id, Float:value)
    Float:cs_get_c4_explode_time(weapon_id)
    cs_set_c4_explode_time(weapon_id, Float:value)

*******************************************************************************/

// Comment if you use AMX 0.9.9.
#define AMX_2006

/*******************************************************************************
*  This program is free software; you can redistribute it and/or modify it
*  under the terms of the GNU General Public License as published by the
*  Free Software Foundation; either version 2 of the License, or (at
*  your option) any later version.
*
*  This program is distributed in the hope that it will be useful, but
*  WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
*  General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software Foundation,
*  Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*  In addition, as a special exception, the author gives permission to
*  link the code of this program with the Half-Life Game Engine ("HL
*  Engine") and Modified Game Libraries ("MODs") developed by Valve,
*  L.L.C ("Valve"). You must obey the GNU General Public License in all
*  respects for all of the code used other than the HL Engine and MODs
*  from Valve. If you modify this file, you may extend this exception
*  to your version of the file, but you are not obligated to do so. If
*  you do not wish to do so, delete this exception statement from your
*  version.
*******************************************************************************/

#if defined _cstrike_included
  #endinput
#endif
#define _cstrike_included

#include <amxmod>
#include <Vexd_Utilities>

#define HAS_SHIELD (1<<24)

#define OFFSET_ARMOR_TYPE       112
#define OFFSET_TEAM             114
#define OFFSET_CSMONEY          115
#define OFFSET_PRIMARYWEAPON    116
#define OFFSET_INTERNAL_MODEL   126
#define OFFSET_NVGOGGLES        129
#define OFFSET_DEFUSE_PLANT     193
#define OFFSET_VIP              209
#define OFFSET_TK               216
#define OFFSET_MAPZONE          235
#define OFFSET_ISDRIVING        350
#define OFFSET_STATIONARY       362

#define OFFSET_AWM_AMMO         377
#define OFFSET_SCOUT_AMMO       378
#define OFFSET_PARA_AMMO        379
#define OFFSET_FAMAS_AMMO       380
#define OFFSET_M3_AMMO          381
#define OFFSET_USP_AMMO         382
#define OFFSET_FIVESEVEN_AMMO   383
#define OFFSET_DEAGLE_AMMO      384
#define OFFSET_P228_AMMO        385
#define OFFSET_GLOCK_AMMO       386
#define OFFSET_FLASH_AMMO       387
#define OFFSET_HE_AMMO          388
#define OFFSET_SMOKE_AMMO       389
#define OFFSET_C4_AMMO          390

#define OFFSET_CSDEATHS         444
#define OFFSET_SHIELD           510

#define OFFSET_WEAPON_TYPE       43
#define OFFSET_CLIPAMMO          51
#define OFFSET_SILENCER_FIREMODE 74

#define OFFSET_LASTACTIVITY     124

#define OFFSET_HOSTAGE_ID       487
#define OFFSET_HOSTAGE_FOLLOW    86
#define OFFSET_HOSTAGE_KILLS    217
#define OFFSET_HOSTAGE_LASTUSE  483
#define OFFSET_HOSTAGE_NEXTUSE  100

#define OFFSET_C4_EXPLODE_TIME  100

#define OFFSET_ARMOURY_TYPE      34
#define OFFSET_ZOOM_TYPE        363

#define M4A1_SILENCED           (1<<2)
#define M4A1_ATTACHSILENCEANIM      6
#define M4A1_DETACHSILENCEANIM     13
#define USP_SILENCED            (1<<0)
#define USP_ATTACHSILENCEANIM       7
#define USP_DETACHSILENCEANIM      15

#define GLOCK_SEMIAUTOMATIC 0
#define GLOCK_BURSTMODE     2
#define FAMAS_AUTOMATIC     0
#define FAMAS_BURSTMODE    16

#define PLAYER_IS_VIP (1<<8)

#define TEAM_UNASSIGNED 0
#define TEAM_T          1
#define TEAM_CT         2
#define TEAM_SPECTATOR  3

#define CAN_PLANT_BOMB  (1<<8)
#define HAS_DEFUSE_KIT  (1<<16)

#define DEFUSER_COLOUR_R   0
#define DEFUSER_COLOUR_G 160
#define DEFUSER_COLOUR_B   0

#define HAS_NVGOGGLES (1<<0)

#define SCOREATTRIB_NOTHING 0
#define SCOREATTRIB_DEAD    1
#define SCOREATTRIB_BOMB    2
#define SCOREATTRIB_VIP     4

#define CSA_MP5NAVY       0
#define CSA_TMP           1
#define CSA_P90           2
#define CSA_MAC10         3
#define CSA_AK47          4
#define CSA_SG552         5
#define CSA_M4A1          6
#define CSA_AUG           7
#define CSA_SCOUT         8
#define CSA_G3SG1         9
#define CSA_AWP          10
#define CSA_M3           11
#define CSA_XM1014       12
#define CSA_M249         13
#define CSA_FLASHBANG    14
#define CSA_HEGRENADE    15
#define CSA_VEST         16
#define CSA_VESTHELM     17
#define CSA_SMOKEGRENADE 18

#define PLAYER_IN_BUYZONE        (1<<0)
#define PLAYER_IN_BOMB_TARGET    (1<<1)
#define PLAYER_IN_HOSTAGE_RESCUE (1<<2)
#define PLAYER_IN_ESCAPEZONE     (1<<3)
#define PLAYER_IN_VIP_SAFETYZONE (1<<4)

#define CS_NO_ZOOM            0x5A
#define CS_FIRST_ZOOM         0x28
#define CS_SECOND_AWP_ZOOM     0xA
#define CS_SECOND_NONAWP_ZOOM  0xF
#define CS_AUGSG552_ZOOM      0x37

#if defined AMX_2006
  #define reportError report_error
#else
  #define reportError server_print
#endif

/* Checks if the user/entity is a player by classname (return true or false). */
stock bool:is_player(id) {
  new classname[8]
  return bool:(entity_get_string(id, EV_SZ_classname, classname, 7) == 6 && equal(classname, "player"))
}

/* Checks if the user/entity is a player if his number is valid
* (between 1 and maxplayers) and if he's connected (return true or false). */
stock bool:cs_check_player(id, const msg[]) {
  static maxplayers
  if(maxplayers == 0) {
    maxplayers = get_maxplayers()
  }
  if(!(1 <= id <= maxplayers)) {
    reportError("%s: Player %d invalid", msg, id)
    return true
  }
  if(!is_user_connected(id)) {
    reportError("%s: Player %d not in-game", msg, id)
    return true
  }
  return false
}

/* Checks if the entity is valid or not (returns true or false). */
stock bool:cs_check_entity(ent, const msg[]) {
  static maxentities
  if(maxentities == 0) {
    maxentities = get_maxentities()
  }
  if((ent < 1) || (ent > maxentities)) {
    reportError("%s: Entity %d out of range", msg, ent)
    return true
  }
  if(!is_entity(ent)) {
    reportError("%s: Entity %d invalid", msg, ent)
    return true
  }
  return false
}

/* Returns users money. */
stock cs_get_user_money(id) {
  if(cs_check_player(id, "cs_get_user_money")) return 0

  return get_offset_int(id, OFFSET_CSMONEY)
}

/* Gives money to user. If flash is 1, the difference between new and old amount will flash red or green. */
stock cs_set_user_money(id, money, flash = 1) {
  if(cs_check_player(id, "cs_set_user_money")) return 0

  set_offset_int(id, OFFSET_CSMONEY, money)
  message_begin(MSG_ONE, get_user_msgid("Money"), {0,0,0}, id)
  write_long(money)
  write_byte(flash ? 1 : 0)
  message_end()
  return 1
}

/* Returns player deaths. */
stock cs_get_user_deaths(id) {
  if(cs_check_player(id, "cs_get_user_deaths")) return 0

  return get_offset_int(id, OFFSET_CSDEATHS)
}

/* Sets player deaths. */
stock cs_set_user_deaths(id, newdeaths) {
  if(cs_check_player(id, "cs_set_user_deaths")) return 0

  set_offset_int(id, OFFSET_CSDEATHS, newdeaths)
  message_begin(MSG_ALL, get_user_msgid("ScoreInfo"))
  write_byte(id)
  write_short(get_user_frags(id))
  write_short(newdeaths)
  write_short(0)
  write_short(get_user_team(id))
  message_end()
  return 1
}

/* Gets weapon type. Corresponds to CSW_* in amxconst.inc: 1 is CSW_P228, 2 is CSW_SCOUT and so on... */
stock cs_get_weapon_id(weapon_id) {
  if(cs_check_entity(weapon_id, "cs_get_weapon_id")) return 0

  return get_offset_int(weapon_id, OFFSET_WEAPON_TYPE, 4)
}

/* Returns 1 if weapon is silenced, else 0. */
stock cs_get_weapon_silen(weapon_id) {
  if(cs_check_entity(weapon_id, "cs_get_weapon_silen")) return 0

  new weapontype = get_offset_int(weapon_id, OFFSET_WEAPON_TYPE, 4)
  new silencemode = get_offset_int(weapon_id, OFFSET_SILENCER_FIREMODE, 4)
  switch(weapontype) {
    case CSW_M4A1:
      if(silencemode & M4A1_SILENCED)
        return 1
    case CSW_USP:
      if(silencemode & USP_SILENCED)
        return 1
  }
  return 0
}

/* Sets whether a weapon is silenced or not.
 * If silence = 1, weapon will be silenced, 0 and silencer will be removed.
 * Only USP and M4A1 can be silenced. */
stock cs_set_weapon_silen(weapon_id, silence = 1, draw_animation = 1) {
  if(cs_check_entity(weapon_id, "cs_set_weapon_silen")) return 0

  new weapontype = get_offset_int(weapon_id, OFFSET_WEAPON_TYPE, 4)
  new silencemode = get_offset_int(weapon_id, OFFSET_SILENCER_FIREMODE, 4)

  switch(weapontype) {
    case CSW_M4A1: {
      if(silence == 1) {
        if(!(silencemode & M4A1_SILENCED)) {
          silencemode |= M4A1_SILENCED
          set_offset_int(weapon_id, OFFSET_SILENCER_FIREMODE, silencemode, 4)
          new owner = entity_get_edict(weapon_id, EV_ENT_owner)
          if(draw_animation && is_player(owner))
            entity_set_int(owner, EV_INT_weaponanim, M4A1_ATTACHSILENCEANIM)
        }
      }
      else if(silencemode & M4A1_SILENCED) {
        silencemode &= ~M4A1_SILENCED
        set_offset_int(weapon_id, OFFSET_SILENCER_FIREMODE, silencemode, 4)
        new owner = entity_get_edict(weapon_id, EV_ENT_owner)
        if(draw_animation && is_player(owner))
          entity_set_int(owner, EV_INT_weaponanim, M4A1_DETACHSILENCEANIM)
      }
    }
    case CSW_USP: {
      if(silence == 1) {
        if(!(silencemode & USP_SILENCED)) {
          silencemode |= USP_SILENCED
          set_offset_int(weapon_id, OFFSET_SILENCER_FIREMODE, silencemode, 4)
          new owner = entity_get_edict(weapon_id, EV_ENT_owner)
          if(draw_animation && is_player(owner))
            entity_set_int(owner, EV_INT_weaponanim, USP_ATTACHSILENCEANIM)
        }
      }
      else if(silencemode & USP_SILENCED) {
        silencemode &= ~USP_SILENCED
        set_offset_int(weapon_id, OFFSET_SILENCER_FIREMODE, silencemode, 4)
        new owner = entity_get_edict(weapon_id, EV_ENT_owner)
        if(draw_animation && is_player(owner))
          entity_set_int(owner, EV_INT_weaponanim, USP_DETACHSILENCEANIM)
      }
    }
    default:
      return 0
  }
  return 1
}

/* Returns 1 if specified weapon is in burst mode. */
stock cs_get_weapon_burst(weapon_id) {
  if(cs_check_entity(weapon_id, "cs_get_weapon_burst")) return 0

  new weapontype = get_offset_int(weapon_id, OFFSET_WEAPON_TYPE, 4)
  new firemode = get_offset_int(weapon_id, OFFSET_SILENCER_FIREMODE, 4)

  switch(weapontype) {
    case CSW_GLOCK18: {
      if (firemode == GLOCK_BURSTMODE)
        return 1
    }
    case CSW_FAMAS: {
      if (firemode == FAMAS_BURSTMODE)
        return 1
    }
  }
  return 0
}

/* Sets whether the weapon is in burst mode.
 * If burstmode = 1, weapon will be changed to burst mode, 0 and non-burst mode (semiautomatic/automatic) will be activated.
 * Only GLOCK and FAMAS can enter/leave burst mode. */
stock cs_set_weapon_burst(weapon_id, burstmode = 1) {
  if(cs_check_entity(weapon_id, "cs_set_weapon_burst")) return 0

  new weapontype = get_offset_int(weapon_id, OFFSET_WEAPON_TYPE, 4)
  new firemode = get_offset_int(weapon_id, OFFSET_SILENCER_FIREMODE, 4)
  new previousMode = firemode

  switch (weapontype) {
    case CSW_GLOCK18: {
      if(burstmode) {
        if (previousMode != GLOCK_BURSTMODE) {
          firemode = GLOCK_BURSTMODE
          set_offset_int(weapon_id, OFFSET_SILENCER_FIREMODE, firemode, 4)

          new owner = entity_get_edict(weapon_id, EV_ENT_owner)
          if(is_player(owner)) {
            message_begin(MSG_ONE, get_user_msgid("TextMsg"), {0,0,0}, owner)
            write_byte(4)
            write_string("#Switch_To_BurstFire")
            message_end()
          }
        }
      }
      else if (previousMode != GLOCK_SEMIAUTOMATIC) {
        firemode = GLOCK_SEMIAUTOMATIC
        set_offset_int(weapon_id, OFFSET_SILENCER_FIREMODE, firemode, 4)

        new owner = entity_get_edict(weapon_id, EV_ENT_owner)
        if(is_player(owner)) {
          message_begin(MSG_ONE, get_user_msgid("TextMsg"), {0,0,0}, owner)
          write_byte(4)
          write_string("#Switch_To_SemiAuto")
          message_end()
        }
      }
    }
    case CSW_FAMAS: {
      if (burstmode) {
        if (previousMode != FAMAS_BURSTMODE) {
          firemode = FAMAS_BURSTMODE
          set_offset_int(weapon_id, OFFSET_SILENCER_FIREMODE, firemode, 4)

          new owner = entity_get_edict(weapon_id, EV_ENT_owner)
          if(is_player(owner)) {
            message_begin(MSG_ONE, get_user_msgid("TextMsg"), {0,0,0}, owner)
            write_byte(4)
            write_string("#Switch_To_BurstFire")
            message_end()
          }
        }
      }
      else if (previousMode != FAMAS_AUTOMATIC) {
        firemode = FAMAS_AUTOMATIC
        set_offset_int(weapon_id, OFFSET_SILENCER_FIREMODE, firemode, 4)

        new owner = entity_get_edict(weapon_id, EV_ENT_owner)
        if(is_player(owner)) {
          message_begin(MSG_ONE, get_user_msgid("TextMsg"), {0,0,0}, owner)
          write_byte(4)
          write_string("#Switch_To_FullAuto")
          message_end()
        }
      }
    }
    default:
      return 0
  }
  return 1
}

/* Armor type enum. Used for cs_get_user_armor()/cs_set_user_armor() natives (just below). */
enum CsArmorType {
  CS_ARMOR_NONE = 0, // No armor
  CS_ARMOR_KEVLAR = 1, // Armor
  CS_ARMOR_VESTHELM = 2 // Armor and helmet
};

/* Returns armor value and sets by reference the armor type in second parameter. */
stock cs_get_user_armor(id, &CsArmorType:armortype) {
  if(cs_check_player(id, "cs_get_user_armor")) return 0

  switch(get_offset_int(id, OFFSET_ARMOR_TYPE)) {
    case 0: armortype = CS_ARMOR_NONE
    case 1: armortype = CS_ARMOR_KEVLAR
    case 2: armortype = CS_ARMOR_VESTHELM
  }
  return floatround(entity_get_float(id, EV_FL_armorvalue))
}

/* Sets player armor.
 * Use this instead of fun's set_user_armor.
 * Appropriate message to update client's HUD will be sent if armortype is kevlar or vesthelm. */
stock cs_set_user_armor(id, armorvalue, CsArmorType:armortype) {
  if(cs_check_player(id, "cs_set_user_armor")) return 0

  switch(armortype) {
    case CS_ARMOR_NONE: set_offset_int(id, OFFSET_ARMOR_TYPE, 0)
    case CS_ARMOR_KEVLAR: set_offset_int(id, OFFSET_ARMOR_TYPE, 1)
    case CS_ARMOR_VESTHELM: set_offset_int(id, OFFSET_ARMOR_TYPE, 2)
  }
  entity_set_float(id, EV_FL_armorvalue, float(armorvalue))
  if(armortype == CS_ARMOR_KEVLAR || armortype == CS_ARMOR_VESTHELM) {
    message_begin(MSG_ONE, get_user_msgid("ArmorType"), {0,0,0}, id)
    write_byte((armortype == CS_ARMOR_VESTHELM) ? 1 : 0)
    message_end()
  }
  return 1
}

/* Is user vip? Returns 1 if true, 0 if false. */
stock cs_get_user_vip(id) {
  if(cs_check_player(id, "cs_get_user_vip")) return 0

  if(get_offset_int(id, OFFSET_VIP) & PLAYER_IS_VIP) return 1
  return 0
}

/* Sets whether a user is the VIP.
 * If vip = 1, user is set to vip.
 * If model = 1, then user's model will be changed to VIP model or random CT model if vip = 0.
 * If scoreboard = 1, then scoreboard will be updated to show that user is VIP.
 * This shouldn't be used for players on teams other than CT.
 * Note: This is mostly useful for unsetting vips, so they can change teams and/or buy items properly.
 * It does not alter game play; the one being VIP at start of round will retain internal status as VIP; terrorists
 * can terminate him and accomplish their objective, etc. */
stock cs_set_user_vip(id, vip = 1, model = 1, scoreboard = 1) {
  if(cs_check_player(id, "cs_set_user_vip")) return 0

  if(vip == 1) {
    set_offset_int(id, OFFSET_VIP, get_offset_int(id, OFFSET_VIP) | PLAYER_IS_VIP)
    if(model == 1) {
      set_user_model(id, "vip")
      set_offset_int(id, OFFSET_INTERNAL_MODEL, 9)
    }
    if(scoreboard == 1) {
      message_begin(MSG_ALL, get_user_msgid("ScoreAttrib"))
      write_byte(id)
      write_byte(SCOREATTRIB_VIP)
      message_end()
    }
  }
  else {
    set_offset_int(id, OFFSET_VIP, get_offset_int(id, OFFSET_VIP) & ~PLAYER_IS_VIP)

    if(model == 1) {
      new CTmodels[4][] = {"urban", "gsg9", "sas", "gign"}
      new CTenum[4] = {1,5,7,6}
      new randnum = random_num(0,3)
      set_user_model(id, CTmodels[randnum])
      set_offset_int(id, OFFSET_INTERNAL_MODEL, CTenum[randnum])
    }
    
    if(scoreboard == 1) {
      new scoreattrib
      if(entity_get_int(id, EV_INT_deadflag) == DEAD_NO && get_user_health(id) > 0)
        scoreattrib = SCOREATTRIB_NOTHING
      else
        scoreattrib = SCOREATTRIB_DEAD
      message_begin(MSG_ALL, get_user_msgid("ScoreAttrib"))
      write_byte(id)
      write_byte(scoreattrib)
      message_end()
    }
  }
  return 1
}

/* Gets team directly from player's entity.
 * 1 = Terrorist
 * 2 = Counter-Terrorist
 * 3 = Spectator */
enum CsTeams {
  CS_TEAM_UNASSIGNED = 0,
  CS_TEAM_T = 1,
  CS_TEAM_CT = 2,
  CS_TEAM_SPECTATOR = 3
};
enum CsInternalModel {
  CS_DONTCHANGE = 0,
  CS_CT_URBAN = 1,
  CS_T_TERROR = 2,
  CS_T_LEET = 3,
  CS_T_ARCTIC = 4,
  CS_CT_GSG9 = 5,
  CS_CT_GIGN = 6,
  CS_CT_SAS = 7,
  CS_T_GUERILLA = 8,
  CS_CT_VIP = 9,
  CZ_T_MILITIA = 10,
  CZ_CT_SPETSNAZ = 11
};
stock CsTeams:cs_get_user_team(id, &{CsInternalModel,_}:model = CS_DONTCHANGE) {
  if(cs_check_player(id, "cs_get_user_team")) return CS_TEAM_UNASSIGNED
  switch(get_offset_int(id, OFFSET_INTERNAL_MODEL)) {
    case 0: model = CS_DONTCHANGE
    case 1: model = CS_CT_URBAN
    case 2: model = CS_T_TERROR
    case 3: model = CS_T_LEET
    case 4: model = CS_T_ARCTIC
    case 5: model = CS_CT_GSG9
    case 6: model = CS_CT_GIGN
    case 7: model = CS_CT_SAS
    case 8: model = CS_T_GUERILLA
    case 9: model = CS_CT_VIP
    case 10: model = CZ_T_MILITIA
    case 11: model = CZ_CT_SPETSNAZ
  }
  switch(get_offset_int(id, OFFSET_TEAM)) {
    case 1: return CS_TEAM_T
    case 2: return CS_TEAM_CT
    case 3: return CS_TEAM_SPECTATOR
  }
  return CS_TEAM_UNASSIGNED
}

/* Sets user team without killing player.
 * If model is anything other than CS_DONTCHANGE, that will be set as player's model. */
stock cs_set_user_team(id, {CsTeams,_}:team, {CsInternalModel,_}:model = CS_DONTCHANGE) {
  if(cs_check_player(id, "cs_set_user_team")) return 0

  switch(team) {
    case CS_TEAM_T: set_offset_int(id, OFFSET_TEAM, 1)
    case CS_TEAM_CT: set_offset_int(id, OFFSET_TEAM, 2)
    case CS_TEAM_SPECTATOR: set_offset_int(id, OFFSET_TEAM, 3)
  }
  switch(model) {
    case CS_CT_URBAN: {
      set_user_model(id, "urban")
      set_offset_int(id, OFFSET_INTERNAL_MODEL, 1)
    }
    case CS_T_TERROR: {
      set_user_model(id, "terror")
      set_offset_int(id, OFFSET_INTERNAL_MODEL, 2)
    }
    case CS_T_LEET: {
      set_user_model(id, "leet")
      set_offset_int(id, OFFSET_INTERNAL_MODEL, 3)
    }
    case CS_T_ARCTIC: {
      set_user_model(id, "arctic")
      set_offset_int(id, OFFSET_INTERNAL_MODEL, 4)
    }
    case CS_CT_GSG9: {
      set_user_model(id, "gsg9")
      set_offset_int(id, OFFSET_INTERNAL_MODEL, 5)
    }
    case CS_CT_GIGN: {
      set_user_model(id, "gign")
      set_offset_int(id, OFFSET_INTERNAL_MODEL, 6)
    }
    case CS_CT_SAS: {
      set_user_model(id, "sas")
      set_offset_int(id, OFFSET_INTERNAL_MODEL, 7)
    }
    case CS_T_GUERILLA: {
      set_user_model(id, "guerilla")
      set_offset_int(id, OFFSET_INTERNAL_MODEL, 8)
    }
    case CS_CT_VIP: {
      set_user_model(id, "vip")
      set_offset_int(id, OFFSET_INTERNAL_MODEL, 9)
    }
    case CZ_T_MILITIA: {
      set_user_model(id, "militia")
      set_offset_int(id, OFFSET_INTERNAL_MODEL, 10)
    }
    case CZ_CT_SPETSNAZ: {
      set_user_model(id, "spetsnaz")
      set_offset_int(id, OFFSET_INTERNAL_MODEL, 11)
    }
  }

  new teaminfo[32]
  switch(team) {
    case CS_TEAM_UNASSIGNED: {
      copy(teaminfo, 31, "UNASSIGNED")
    }
    case CS_TEAM_T: {
      copy(teaminfo, 31, "TERRORIST")
    }
    case CS_TEAM_CT: {
      copy(teaminfo, 31, "CT")
    }
    case CS_TEAM_SPECTATOR: {
      copy(teaminfo, 31, "SPECTATOR")
    }
  }
  message_begin(MSG_ALL, get_user_msgid("TeamInfo"))
  write_byte(id)
  write_string(teaminfo)
  message_end()
  return 1
}

/* Is user in buyzone? Returns 1 when true, 0 when false. */
stock cs_get_user_buyzone(id) {
  if(cs_check_player(id, "cs_get_user_buyzone")) return 0

  return (get_offset_int(id, OFFSET_MAPZONE) & PLAYER_IN_BUYZONE) ? 1 : 0
}

/* Returns 1 if user has the "skill" to plant bomb, else 0.
 * Normally this would only be true for a terrorist carrying a bomb. */
stock cs_get_user_plant(id) {
  if(cs_check_player(id, "cs_get_user_plant")) return 0

  if(get_offset_int(id, OFFSET_DEFUSE_PLANT) & CAN_PLANT_BOMB) return 1
  return 0
}

/* Sets whether a player can plant the bomb.
 * If plant is 1, a user will be set to be able to plant bomb within the usual bomb target areas if having one.
 * You should use this if you give a player a weapon_c4, or he won't be able to plant it
 * without dropping it and picking it up again (only possible for terrorists).
 * If showbombicon is 1, the green C4 icon will be shown on user hud (if plant "skill" was enabled). */
stock cs_set_user_plant(id, plant = 1, showbombicon = 1) {
  if(cs_check_player(id, "cs_set_user_plant")) return 0

  new plantskill = get_offset_int(id, OFFSET_DEFUSE_PLANT)

  if(plant) {
    plantskill |= CAN_PLANT_BOMB
    set_offset_int(id, OFFSET_DEFUSE_PLANT, plantskill)
    if(showbombicon) {
      message_begin(MSG_ONE, get_user_msgid("StatusIcon"), {0,0,0}, id)
      write_byte(1)
      write_string("c4")
      write_byte(DEFUSER_COLOUR_R)
      write_byte(DEFUSER_COLOUR_G)
      write_byte(DEFUSER_COLOUR_B)
      message_end()
    }
  }
  else {
    plantskill &= ~CAN_PLANT_BOMB
    set_offset_int(id, OFFSET_DEFUSE_PLANT, plantskill)
    message_begin(MSG_ONE, get_user_msgid("StatusIcon"), {0,0,0}, id)
    write_byte(0)
    write_string("c4")
    message_end()
  }
  return 1
}

/* Returns 1 if user has a defuse kit. */
stock cs_get_user_defuse(id) {
  if(cs_check_player(id, "cs_get_user_defuse")) return 0

  if(get_offset_int(id, OFFSET_DEFUSE_PLANT) & HAS_DEFUSE_KIT) return 1
  return 0
}

/* Sets whether a user has the defusekit.
 * If defusekit is 1, the user will have a defuse kit.
 * You can specify a different colour for the defuse kit icon showing on hud. Default is the normal green.
 * You can specify an icon. Default is "defuser". Set flash to 1 if you want the icon to flash red. */
stock cs_set_user_defuse(id, defusekit = 1, r = 0, g = 160, b = 0, icon[] = "defuser", flash = 0) {
  if(cs_check_player(id, "cs_set_user_defuse")) return 0

  new defuse = get_offset_int(id, OFFSET_DEFUSE_PLANT)

  if(defusekit) {
    new colour[3] = {DEFUSER_COLOUR_R, DEFUSER_COLOUR_G, DEFUSER_COLOUR_B}
    if(r != -1) colour[0] = r
    if(g != -1) colour[1] = g
    if(b != -1) colour[2] = b
    
    entity_set_int(id, EV_INT_body, 1)

    defuse |= HAS_DEFUSE_KIT
    set_offset_int(id, OFFSET_DEFUSE_PLANT, defuse)
    message_begin(MSG_ONE, get_user_msgid("StatusIcon"), {0,0,0}, id)
    write_byte((flash == 1) ? 2 : 1)
    write_string(icon[0] ? icon : "defuser")
    write_byte(colour[0])
    write_byte(colour[1])
    write_byte(colour[2])
    message_end()
  }
  else {
    defuse &= ~HAS_DEFUSE_KIT
    set_offset_int(id, OFFSET_DEFUSE_PLANT, defuse)
    message_begin(MSG_ONE, get_user_msgid("StatusIcon"), {0,0,0}, id)
    write_byte(0)
    write_string("defuser")
    message_end()
    entity_set_int(id, EV_INT_body, 0)
  }
  return 1
}

/* Gets amount of ammo in backpack on a user for a specific weapon.
 * Look in amxconst.inc for weapon types: CSW_*.
 * Weapons on the same line uses the same ammo type:
 *  awm
 *  scout, ak, g3
 *  para
 *  famas, m4a1, aug, sg550, galil, sg552
 *  m3, xm
 *  usp, ump, mac
 *  fiveseven, p90
 *  deagle
 *  p228
 *  glock, mp5, tmp, elites
 *  flash
 *  he
 *  smoke */
stock cs_get_user_bpammo(id, weapon) {
  if(cs_check_player(id, "cs_get_user_bpammo")) return 0

  new offset

  switch(weapon) {
    case CSW_AWP: {
      offset = OFFSET_AWM_AMMO
    }
    case CSW_SCOUT: {
      offset = OFFSET_SCOUT_AMMO
    }
    case CSW_AK47: {
      offset = OFFSET_SCOUT_AMMO
    }
    case CSW_G3SG1: {
      offset = OFFSET_SCOUT_AMMO
    }
    case CSW_M249: {
      offset = OFFSET_PARA_AMMO
    }
    case CSW_FAMAS: {
      offset = OFFSET_FAMAS_AMMO
    }
    case CSW_M4A1: {
      offset = OFFSET_FAMAS_AMMO
    }
    case CSW_AUG: {
      offset = OFFSET_FAMAS_AMMO
    }
    case CSW_SG550: {
      offset = OFFSET_FAMAS_AMMO
    }
    case CSW_GALIL: {
      offset = OFFSET_FAMAS_AMMO
    }
    case CSW_SG552: {
      offset = OFFSET_FAMAS_AMMO
    }
    case CSW_M3: {
      offset = OFFSET_M3_AMMO
    }
    case CSW_XM1014: {
      offset = OFFSET_M3_AMMO
    }
    case CSW_USP: {
      offset = OFFSET_USP_AMMO
    }
    case CSW_UMP45: {
      offset = OFFSET_USP_AMMO
    }
    case CSW_MAC10: {
      offset = OFFSET_USP_AMMO
    }
    case CSW_FIVESEVEN: {
      offset = OFFSET_FIVESEVEN_AMMO
    }
    case CSW_P90: {
      offset = OFFSET_FIVESEVEN_AMMO
    }
    case CSW_DEAGLE: {
      offset = OFFSET_DEAGLE_AMMO
    }
    case CSW_P228: {
      offset = OFFSET_P228_AMMO
    }
    case CSW_GLOCK18: {
      offset = OFFSET_GLOCK_AMMO
    }
    case CSW_MP5NAVY: {
      offset = OFFSET_GLOCK_AMMO
    }
    case CSW_TMP: {
      offset = OFFSET_GLOCK_AMMO
    }
    case CSW_ELITE: {
      offset = OFFSET_GLOCK_AMMO
    }
    case CSW_FLASHBANG: {
      offset = OFFSET_FLASH_AMMO
    }
    case CSW_HEGRENADE: {
      offset = OFFSET_HE_AMMO
    }
    case CSW_SMOKEGRENADE: {
      offset = OFFSET_SMOKE_AMMO
    }
    case CSW_C4: {
      offset = OFFSET_C4_AMMO
    }
    default: {
      reportError("cs_get_user_bpammo: Invalid weapon id %d", weapon)
      return 0
    }
  }
  return get_offset_int(id, offset)
}

/* Restocks/removes ammo in a user's backpack. */
stock cs_set_user_bpammo(id, weapon, amount) {
  if(cs_check_player(id, "cs_set_user_bpammo")) return 0

  new offset

  switch(weapon) {
    case CSW_AWP: {
      offset = OFFSET_AWM_AMMO
    }
    case CSW_SCOUT: {
      offset = OFFSET_SCOUT_AMMO
    }
    case CSW_AK47: {
      offset = OFFSET_SCOUT_AMMO
    }
    case CSW_G3SG1: {
      offset = OFFSET_SCOUT_AMMO
    }
    case CSW_M249: {
      offset = OFFSET_PARA_AMMO
    }
    case CSW_FAMAS: {
      offset = OFFSET_FAMAS_AMMO
    }
    case CSW_M4A1: {
      offset = OFFSET_FAMAS_AMMO
    }
    case CSW_AUG: {
      offset = OFFSET_FAMAS_AMMO
    }
    case CSW_SG550: {
      offset = OFFSET_FAMAS_AMMO
    }
    case CSW_GALIL: {
      offset = OFFSET_FAMAS_AMMO
    }
    case CSW_SG552: {
      offset = OFFSET_FAMAS_AMMO
    }
    case CSW_M3: {
      offset = OFFSET_M3_AMMO
    }
    case CSW_XM1014: {
      offset = OFFSET_M3_AMMO
    }
    case CSW_USP: {
      offset = OFFSET_USP_AMMO
    }
    case CSW_UMP45: {
      offset = OFFSET_USP_AMMO
    }
    case CSW_MAC10: {
      offset = OFFSET_USP_AMMO
    }
    case CSW_FIVESEVEN: {
      offset = OFFSET_FIVESEVEN_AMMO
    }
    case CSW_P90: {
      offset = OFFSET_FIVESEVEN_AMMO
    }
    case CSW_DEAGLE: {
      offset = OFFSET_DEAGLE_AMMO
    }
    case CSW_P228: {
      offset = OFFSET_P228_AMMO
    }
    case CSW_GLOCK18: {
      offset = OFFSET_GLOCK_AMMO
    }
    case CSW_MP5NAVY: {
      offset = OFFSET_GLOCK_AMMO
    }
    case CSW_TMP: {
      offset = OFFSET_GLOCK_AMMO
    }
    case CSW_ELITE: {
      offset = OFFSET_GLOCK_AMMO
    }
    case CSW_FLASHBANG: {
      offset = OFFSET_FLASH_AMMO
    }
    case CSW_HEGRENADE: {
      offset = OFFSET_HE_AMMO
    }
    case CSW_SMOKEGRENADE: {
      offset = OFFSET_SMOKE_AMMO
    }
    case CSW_C4: {
      offset = OFFSET_C4_AMMO
    }
    default: {
      reportError("cs_set_user_bpammo: Invalid weapon id %d", weapon)
      return 0
    }
  }
  set_offset_int(id, offset, amount)
  return 1
}

/* Does user have night vision goggles? */
stock cs_get_user_nvg(id) {
  if(cs_check_player(id, "cs_get_user_nvg")) return 0

  if(get_offset_int(id, OFFSET_NVGOGGLES) & HAS_NVGOGGLES) return 1
  return 0
}

/* Sets nvgoggles to 1 to give night vision goggles to index. Set it to 0 to remove them. */
stock cs_set_user_nvg(id, nvgoggles = 1) {
  if(cs_check_player(id, "cs_set_user_nvg")) return 0

  new defusekit = get_offset_int(id, OFFSET_NVGOGGLES)

  if(nvgoggles) {
    if (defusekit & HAS_NVGOGGLES) {
      message_begin(MSG_ONE, get_user_msgid("TextMsg"), {0,0,0}, id)
      write_byte(4)
      write_string("#Already_Have_One")
      message_end()
    }
    else {
      defusekit |= HAS_NVGOGGLES
      set_offset_int(id, OFFSET_NVGOGGLES, defusekit)
    }
  }
  else {
    defusekit &= ~HAS_NVGOGGLES
    set_offset_int(id, OFFSET_NVGOGGLES, defusekit)
  }
  return 1
}

/* Gets a user model. */
stock cs_get_user_model(id, model[], len) {
  if(cs_check_player(id, "cs_get_user_model")) return 0

  return entity_get_string(id, EV_SZ_model, model, len)
}

/* Sets a user model. */
stock cs_set_user_model(id, const model[]) {
  if(cs_check_player(id, "cs_set_user_model")) return 0

  set_user_model(id, model)
  return 1
}

/* Uses to reset model to standard selected model. */
stock cs_reset_user_model(id) {
  if(cs_check_player(id, "cs_reset_user_model")) return 0

  set_user_model(id)
  return 1
}

/* Gets unique hostage id. */
stock cs_get_hostage_id(hostage_id) {
  if(cs_check_entity(hostage_id, "cs_get_hostage_id")) return 0

  new classname[32]
  entity_get_string(hostage_id, EV_SZ_classname, classname, 31)
  if(!equal(classname, "hostage_entity")) {
    reportError("cs_get_hostage_id: Entity %d (^"%s^") is not a hostage", hostage_id, classname)
    return 0
  }
  return get_offset_int(hostage_id, OFFSET_HOSTAGE_ID)
}

/* Returns index of entity (does not have to be a player) which hostage is following.
 * 0 is hostage doesn't follow anything.
 * Note: This native does not work on Condition Zero, which has a different hostage AI than CS. */
stock cs_get_hostage_foll(hostage_id) {
  if(cs_check_entity(hostage_id, "cs_get_hostage_foll")) return 0

  new mod_name[32]
  get_modname(mod_name, 31)
  if(equal(mod_name, "czero")) {
    reportError("cs_get_hostage_foll: This stock doesn't work on Condition Zero")
    return 0
  }

  new classname[32]
  entity_get_string(hostage_id, EV_SZ_classname, classname, 31)
  if(!equal(classname, "hostage_entity")) {
    reportError("cs_get_hostage_foll: Entity %d (^"%s^") is not a hostage", hostage_id, classname)
    return 0
  }

  new following = get_offset_int(hostage_id, OFFSET_HOSTAGE_FOLLOW)
  if(following == 0) return following

  return pointer_to_index(following)
}

/* Sets hostage to follow entity specified in followedindex. Does not have to be a player.
 * If followedindex is 0 the hostage will stop following.
 * Note: This native does not work on Condition Zero, which has a different hostage AI than CS. */
stock cs_set_hostage_foll(hostage_id, followedid = 0) {
  if(cs_check_entity(hostage_id, "cs_set_hostage_foll")) return 0

  new mod_name[32]
  get_modname(mod_name, 31)
  if(equal(mod_name, "czero")) {
    reportError("cs_set_hostage_foll: This stock doesn't work on Condition Zero")
    return 0
  }

  new classname[32]
  entity_get_string(hostage_id, EV_SZ_classname, classname, 31)
  if(!equal(classname, "hostage_entity")) {
    reportError("cs_set_hostage_foll: Entity %d (^"%s^") is not a hostage", hostage_id, classname)
    return 0
  }

  if(followedid == 0) {
    set_offset_int(hostage_id, OFFSET_HOSTAGE_FOLLOW, 0)
    return 1
  }

  if(cs_check_entity(followedid, "cs_set_hostage_foll")) return 0

  set_offset_int(hostage_id, OFFSET_HOSTAGE_FOLLOW, index_to_pointer(followedid))
  return 1
}

/* Returns amount of ammo in weapon's clip. */
stock cs_get_weapon_ammo(weapon_id) {
  if(cs_check_entity(weapon_id, "cs_get_weapon_ammo")) return 0

  return get_offset_int(weapon_id, OFFSET_CLIPAMMO, 4)
}

/* Sets amount of ammo in weapon's clip. */
stock cs_set_weapon_ammo(weapon_id, newammo) {
  if(cs_check_entity(weapon_id, "cs_set_weapon_ammo")) return 0

  set_offset_int(weapon_id, OFFSET_CLIPAMMO, newammo, 4)
  return 1
}

/* Returns 1 when user has a primary weapon OR a shield in inventory, else 0. */
stock cs_get_user_hasprim(id) {
  if(cs_check_player(id, "cs_get_user_hasprim")) return 0

  return get_offset_int(id, OFFSET_PRIMARYWEAPON)
}

/* Returns 1 of specified user has tk:ed (team killed). */
stock cs_get_user_tked(id) {
  if(cs_check_player(id, "cs_get_user_tked")) return 0

  return get_offset_int(id, OFFSET_TK)
}

/* Returns 1 of specified user has TKed (team killed).
 * tk = 1 - player has TKed
 * tk = 0 - player hasn't TKed
 * Set subtract to how many frags to subtract.
 * Set subtract to negative value to add frags. */
stock cs_set_user_tked(id, tk = 1, subtract = 1) {
  if(cs_check_player(id, "cs_set_user_tked")) return 0

  if(tk) set_offset_int(id, OFFSET_TK, 1)
  else set_offset_int(id, OFFSET_TK, 0)

  if(subtract) {
    new frags = get_user_frags(id) - subtract
    entity_set_float(id, EV_FL_frags, float(frags))

    message_begin(MSG_ALL, get_user_msgid("ScoreInfo"))
    write_byte(id)
    write_short(frags)
    write_short(get_user_deaths(id))
    write_short(0)
    write_short(get_user_team(id))
    message_end()
  }
  return 1
}

/* Returns different values depending on if user is driving a vehicle - and if so at what speed.
 * 0 - no driving
 * 1 - driving, but standing still
 * 2, 3, 4 - driving, different positive speeds
 * 5 - driving, negative speed (backing)
 * Note: These values were tested quickly, they may differ. */
stock cs_get_user_driving(id) {
  if(cs_check_player(id, "cs_get_user_driving")) return 0

  return get_offset_int(id, OFFSET_ISDRIVING)
}

/* Returns 1 if user is using a stationary gun, else 0. */
stock cs_get_user_stationary(id) {
  if(cs_check_player(id, "cs_get_user_stationary")) return 0

  return get_offset_int(id, OFFSET_STATIONARY)
}

/* Returns 1 if user has a shield, else 0. */
stock cs_get_user_shield(id) {
  if(cs_check_player(id, "cs_get_user_shield")) return 0

  if (get_offset_int(id, OFFSET_SHIELD) & HAS_SHIELD) return 1
  return 0
}

/* Spawns a Counter-Strike player (a little better way to spawn a player). */
stock cs_user_spawn(id) {
  if(cs_check_player(id, "cs_user_spawn")) return 0

  entity_set_int(id, EV_INT_spawnflags, DEAD_RESPAWNABLE)
  DispatchSpawn(id)
  entity_set_int(id, EV_INT_iuser1, 0)
  return 1
}

/* Gets what weapon type (CSW_*) an armoury_entity is. */
stock cs_get_armoury_type(ent_id) {
  if(cs_check_entity(ent_id, "cs_get_armoury_type")) return 0

  new classname[32]
  entity_get_string(ent_id, EV_SZ_classname, classname, 31)
  if(!equal(classname, "armoury_entity")) {
    reportError("cs_get_armoury_type: Entity %d (^"%s^") is not an armoury_entity", ent_id, classname)
    return 0
  }

  new weapontype = get_offset_int(ent_id, OFFSET_ARMOURY_TYPE, 4)

  new weapontype_out
  switch(weapontype) {
    case CSA_MP5NAVY:      weapontype_out = CSW_MP5NAVY
    case CSA_TMP:          weapontype_out = CSW_TMP
    case CSA_P90:          weapontype_out = CSW_P90
    case CSA_MAC10:        weapontype_out = CSW_MAC10
    case CSA_AK47:         weapontype_out = CSW_AK47
    case CSA_SG552:        weapontype_out = CSW_SG552
    case CSA_M4A1:         weapontype_out = CSW_M4A1
    case CSA_AUG:          weapontype_out = CSW_AUG
    case CSA_SCOUT:        weapontype_out = CSW_SCOUT
    case CSA_G3SG1:        weapontype_out = CSW_G3SG1
    case CSA_AWP:          weapontype_out = CSW_AWP
    case CSA_M3:           weapontype_out = CSW_M3
    case CSA_XM1014:       weapontype_out = CSW_XM1014
    case CSA_M249:         weapontype_out = CSW_M249
    case CSA_FLASHBANG:    weapontype_out = CSW_FLASHBANG
    case CSA_HEGRENADE:    weapontype_out = CSW_HEGRENADE
    case CSA_VEST:         weapontype_out = CSW_VEST
    case CSA_VESTHELM:     weapontype_out = CSW_VESTHELM
    case CSA_SMOKEGRENADE: weapontype_out = CSW_SMOKEGRENADE
    default: {
      reportError("cs_get_armoury_type: Unexpected weapon type of %d", ent_id)
      return 0
    }
  }

  return weapontype_out
}

/* Sets an armoury_entity to be of specified type. You will have to set the appropriate model.
 * The second argument, type, should be a CSW_* constant. Not all weapons are supported by Counter-strike.
 * Supported weapons/items: CSW_MP5NAVY, CSW_TMP, CSW_P90, CSW_MAC10, CSW_AK47, CSW_SG552, CSW_M4A1, CSW_AUG, CSW_SCOUT
 * CSW_G3SG1, CSW_AWP, CSW_M3, CSW_XM1014, CSW_M249, CSW_FLASHBANG, CSW_HEGRENADE, CSW_VEST, CSW_VESTHELM, CSW_SMOKEGRENADE */
stock cs_set_armoury_type(ent_id, type) {
  if(cs_check_entity(ent_id, "cs_set_armoury_type")) return 0

  new classname[32]
  entity_get_string(ent_id, EV_SZ_classname, classname, 31)
  if(!equal(classname, "armoury_entity")) {
    reportError("cs_set_armoury_type: Entity %d (^"%s^") is not an armoury_entity", ent_id, classname)
    return 0
  }

  new weapontype
  switch(type) {
    case CSW_MP5NAVY:      weapontype = CSA_MP5NAVY
    case CSW_TMP:          weapontype = CSA_TMP
    case CSW_P90:          weapontype = CSA_P90
    case CSW_MAC10:        weapontype = CSA_MAC10
    case CSW_AK47:         weapontype = CSA_AK47
    case CSW_SG552:        weapontype = CSA_SG552
    case CSW_M4A1:         weapontype = CSA_M4A1
    case CSW_AUG:          weapontype = CSA_AUG
    case CSW_SCOUT:        weapontype = CSA_SCOUT
    case CSW_G3SG1:        weapontype = CSA_G3SG1
    case CSW_AWP:          weapontype = CSA_AWP
    case CSW_M3:           weapontype = CSA_M3
    case CSW_XM1014:       weapontype = CSA_XM1014
    case CSW_M249:         weapontype = CSA_M249
    case CSW_FLASHBANG:    weapontype = CSA_FLASHBANG
    case CSW_HEGRENADE:    weapontype = CSA_HEGRENADE
    case CSW_VEST:         weapontype = CSA_VEST
    case CSW_VESTHELM:     weapontype = CSA_VESTHELM
    case CSW_SMOKEGRENADE: weapontype = CSA_SMOKEGRENADE
    default: {
      reportError("cs_set_armoury_type: Unsupported weapon type: %d", type)
      return 0
    }
  }

  set_offset_int(ent_id, OFFSET_ARMOURY_TYPE, weapontype, 4)

  return 1
}

/* Returns in bitwise form if the user is in a specific map zone.
 * Note: If user can't plant (cs_get_user_plant(index) is 0) then
 * cs_get_user_mapzones(index) & CS_MAPZONE_BOMBTARGET will return 0 too. */
stock cs_get_user_mapzones(id) {
  if(cs_check_player(id, "cs_get_user_mapzones")) return 0
  
  return get_offset_int(id, OFFSET_MAPZONE)
}

/* Zoom type enum. Used for cs_get_user_zoom() native (just below). */
enum {
  CS_RESET_ZOOM = 0,
  CS_SET_NO_ZOOM,
  CS_SET_FIRST_ZOOM,
  CS_SET_SECOND_ZOOM,
  CS_SET_AUGSG552_ZOOM
};

/* Returns how a user is zooming during the native call.
 * Values correspond to the previous enum list, but will return 0 if an error occurred. */
stock cs_get_user_zoom(id) {
  if(cs_check_player(id, "cs_get_user_zoom")) return 0

  switch(get_offset_int(id, OFFSET_ZOOM_TYPE)) {
    case CS_NO_ZOOM: return CS_SET_NO_ZOOM
    case CS_FIRST_ZOOM: return CS_SET_FIRST_ZOOM
    case CS_SECOND_AWP_ZOOM, CS_SECOND_NONAWP_ZOOM: return CS_SET_SECOND_ZOOM
    case CS_AUGSG552_ZOOM: return CS_SET_AUGSG552_ZOOM
  }
  return 0
}

/* Returns the submodel setting of the player.
 * If this is 1, then the user has a backpack or defuser on their model (depending on team). */
stock cs_get_user_submodel(id) {
  if(cs_check_player(id, "cs_get_user_submodel")) return 0

  return entity_get_int(id, EV_INT_body)
}

/* Sets the submodel setting of the player.
 * If this is 1, then the user has a backpack or defuser on their model (depending on team)
 * 0 removes it. */
stock cs_set_user_submodel(id, value) {
  if(cs_check_player(id, "cs_set_user_submodel")) return 0

  entity_set_int(id, EV_INT_body, value)
  return 1
}

/* Gets the user's last activity time. This is the time that CS's internal afk kicker
 * checks to see who has been afk too long. */
stock Float:cs_get_user_lastactivity(id) {
  if(cs_check_player(id, "cs_get_user_lastactivity")) return 0.0

  return get_offset_float(id, OFFSET_LASTACTIVITY)
}

/* Sets the user's last activity time. This is the time that CS's internal afk kicker
 * checks to see who has been afk too long. */
stock cs_set_user_lastactivity(id, Float:value) {
  if(cs_check_player(id, "cs_set_user_lastactivity")) return 0

  set_offset_float(id, OFFSET_LASTACTIVITY, value)
  return 1
}

/* Gets the number of hostages that a user has killed. */
stock cs_get_user_hostagekills(id) {
  if(cs_check_player(id, "cs_get_user_hostagekills")) return 0

  return get_offset_int(id, OFFSET_HOSTAGE_KILLS)
}

/* Sets the number of hostages that a user has killed. */
stock cs_set_user_hostagekills(id, value) {
  if(cs_check_player(id, "cs_set_user_hostagekills")) return 0

  set_offset_int(id, OFFSET_HOSTAGE_KILLS, value)
  return 1
}

/* Gets the time that the hostage was last used. */
stock Float:cs_get_hostage_lastuse(hostage_id) {
  if(cs_check_entity(hostage_id, "cs_get_hostage_lastuse")) return 0.0

  new classname[32]
  entity_get_string(hostage_id, EV_SZ_classname, classname, 31)
  if(!equal(classname, "hostage_entity")) {
    reportError("cs_get_hostage_lastuse: Entity %d (^"%s^") is not a hostage", hostage_id, classname)
    return 0.0
  }
  return get_offset_float(hostage_id, OFFSET_HOSTAGE_LASTUSE)
}

/* Sets the time that the hostage was last used. */
stock cs_set_hostage_lastuse(hostage_id, Float:value) {
  if(cs_check_entity(hostage_id, "cs_set_hostage_lastuse")) return 0

  new classname[32]
  entity_get_string(hostage_id, EV_SZ_classname, classname, 31)
  if(!equal(classname, "hostage_entity")) {
    reportError("cs_set_hostage_lastuse: Entity %d (^"%s^") is not a hostage", hostage_id, classname)
    return 0
  }
  set_offset_float(hostage_id, OFFSET_HOSTAGE_LASTUSE, value)
  return 1
}

/* Gets the time which the hostage can next be used. */
stock Float:cs_get_hostage_nextuse(hostage_id) {
  if(cs_check_entity(hostage_id, "cs_get_hostage_nextuse")) return 0.0

  new classname[32]
  entity_get_string(hostage_id, EV_SZ_classname, classname, 31)
  if(!equal(classname, "hostage_entity")) {
    reportError("cs_get_hostage_nextuse: Entity %d (^"%s^") is not a hostage", hostage_id, classname)
    return 0.0
  }
  return get_offset_float(hostage_id, OFFSET_HOSTAGE_NEXTUSE)
}

/* Sets the time which the hostage can next be used. */
stock cs_set_hostage_nextuse(hostage_id, Float:value) {
  if(cs_check_entity(hostage_id, "cs_set_hostage_nextuse")) return 0

  new classname[32]
  entity_get_string(hostage_id, EV_SZ_classname, classname, 31)
  if(!equal(classname, "hostage_entity")) {
    reportError("cs_set_hostage_nextuse: Entity %d (^"%s^") is not a hostage", hostage_id, classname)
    return 0
  }
  set_offset_float(hostage_id, OFFSET_HOSTAGE_NEXTUSE, value)
  return 1
}

/* Gets the time in which the C4 will explode. */
stock Float:cs_get_c4_explode_time(weapon_id) {
  if(cs_check_entity(weapon_id, "cs_get_c4_explode_time")) return 0.0

  new classname[32]
  entity_get_string(weapon_id, EV_SZ_classname, classname, 31)
  if(!equal(classname, "grenade")) {
    reportError("cs_get_c4_explode_time: Entity %d (^"%s^") is not a C4", weapon_id, classname)
    return 0.0
  }
  return get_offset_float(weapon_id, OFFSET_C4_EXPLODE_TIME)
}

/* Sets the time in which the C4 will explode. */
stock cs_set_c4_explode_time(weapon_id, Float:value) {
  if(cs_check_entity(weapon_id, "cs_set_c4_explode_time")) return 0

  new classname[32]
  entity_get_string(weapon_id, EV_SZ_classname, classname, 31)
  if(!equal(classname, "grenade")) {
    reportError("cs_set_c4_explode_time: Entity %d (^"%s^") is not a C4", weapon_id, classname)
    return 0
  }
  set_offset_float(weapon_id, OFFSET_C4_EXPLODE_TIME, value)
  return 1
}
