/*
 * Math functions
 *
 * (c) 2002-2010 - AMX Mod Team
 * This file is provided as is (no warranties).
 *
 */

#if defined _maths_included
  #endinput
#endif
#define _maths_included

enum anglemode {
  radian = 0,
  degrees,
  grades
}

/* Returns the absolute value of an integer. */
native abs(iInput);

/* Returns the absolute value as a float. */
native Float:fabs(Float:value);

/* Returns the square root of the value as a float. */
native Float:fsqroot(Float:value);

/* Returns the value raised to the power of the exponent, as a float. */
native Float:fpower(Float:value, Float:exponent);

/* Returns the logarithm of a value. Base defaults to 10.0. */
native Float:flog(Float:value, Float:base = 10.0);

/* Returns the sine, cosine or tangent.
 * The input angle may be in radians, degrees or grades. */
native Float:sin(Float:value, anglemode:mode = radian);
native Float:cos(Float:value, anglemode:mode = radian);
native Float:tan(Float:value, anglemode:mode = radian);

/* Returns the hyperbolic sine, cosine or tangent.
 * The input angle may be in radians, degrees or grades. */
native Float:sinh(Float:value, anglemode:mode = radian);
native Float:cosh(Float:value, anglemode:mode = radian);
native Float:tanh(Float:value, anglemode:mode = radian);

/* Returns the angle of a sine, cosine or tangent.
 * The output angle may be in radians, degrees or grades. */
native Float:asin(Float:value, anglemode:mode = radian);
native Float:acos(Float:value, anglemode:mode = radian);
native Float:atan(Float:value, anglemode:mode = radian);
native Float:atan2(Float:value1, Float:value2, anglemode:mode = radian);
